        PROCESSOR 6502
;Print Floating Point Number to Screen as Hexadecimal

usradd  EQU $01   ;Address of USR Routine
fac1    EQU $61   ;Floating Point Accumulator #1
tbuffr  EQU $033C ;Cassette I/O Buffer 
chrout  EQU $FFD2 ;Output Character to Channel

        ORG tbuffr    ;Start 
;Set USR Vector - SYS 828
usrset: LDA #<flthex
        STA usradd
        LDA #>flthex
        STA usradd+1
        RTS

;Display Contents of FAC1 in HEX
flthex: LDX #0
fltlop: LDA fac1,X
        JSR prbyte
        LDA #$20
        JSR chrout
        INX
        CPX #6
        BNE fltlop
        LDA #$0D
        JSR chrout
        RTS

;Print Byte as Two-Digit Hex Number to Console
prbyte: PHA         ;Save Accumulater
        LSR         ;Shift Hi Nybble to Low Nybble
        LSR 
        LSR 
        LSR 
        JSR prhex  ;  and Print it
        PLA         ;Restore Accumulator 
                    ;  and fall into prhex
;Print Low Nybble as Hex Digit to Console
prhex:  AND #$0F    ;Strip High Nybble
        CMP #$0A    ;If Low Nybble >= 10
        BCC prhexc  ;  
        ADC #$06    ;  Convert ':' to 'A'...
prhexc: ADC #$30    ;Convert to ASCII Character
        JMP chrout  ;Print Hex Digit and Return


